<template>
  <ObModal
    ref="mapPopup"
    :edit-form="false"
    :is-nested="true"
    custom-class="ob-logchain-modal-wrapper"
    size="max"
    :isCloseOnOverlay="false"
    :data-qa="dataQa"
  >
    <div class="ob-logchain-modal">
      <div class="ob-logchain-modal__map-container">
        <l-map
          ref="map"
          :zoom="zoom"
          :center="center"
          :options="mapOptions"
          style="height: 100%"
          @click="clickOnMap"
          @update:bounds="boundsUpdate"
        >
          <l-tile-layer :url="url" :attribution="attribution" />
          <template v-if="circles.length">
            <l-circle
              v-for="(circle, index) in circles"
              :key="index"
              :lat-lng="getLatLng(circle)"
              :radius="+circle.zeroInterrogationRadius * 1000"
              color=""
              fillColor="#2FBBFF"
              :fillOpacity="0.3"
            ></l-circle>
          </template>
          <template v-if="locations.length">
            <l-marker
              v-for="point in locations"
              :key="point.title"
              :lat-lng="getLatLng(point)"
              :zIndexOffset="markerZindex(point)"
              @click="clickOnMarker"
              :icon="point.icon"
            >
              <l-tooltip>{{ point.title }}</l-tooltip>
            </l-marker>
          </template>
        </l-map>
      </div>
      <div class="ob-logchain-modal__controls-wrapper">
        <div class="ob-logchain-modal__controls">
          <div class="ob-logchain-modal__controls-locations" v-if="!isVisitPoint">
            <ControlGroup
              height="slim"
              :items="[
                {
                  label: '',
                  value: 'bbb964b2-b799-11e9-a2a3-2a2ae2dbcce4',
                  tooltipIcon: 'airplane-sm',
                  tooltip: 'Аэропорт',
                },
                {
                  label: '',
                  value: '4adf706e-0be2-4383-b680-a73c959b9e2c',
                  tooltipIcon: 'train-sm',
                  tooltip: 'ЖД Станция',
                },
                {
                  label: '',
                  value: '4adf706e-0be2-4383-b680-a73c959b9e4c',
                  tooltipIcon: 'container-sm',
                  tooltip: 'Контейнерный терминал',
                },
                {
                  label: '',
                  value: '5919a99f-d840-4855-b158-5ba957076603',
                  tooltipIcon: 'city-sm',
                  tooltip: 'Опорная точка',
                },
                {
                  label: '',
                  value: '4adf706e-0be2-4383-b680-a73c959b9e3c',
                  tooltipIcon: 'restrict-sm',
                  tooltip: 'Пункт таможенного оформления/СВХ',
                },
                {
                  label: '',
                  value: 'a2166b4d-27a9-41ce-9fc8-8bfd21baa8d7',
                  tooltipIcon: 'police-sm',
                  tooltip: 'Пограничный переход',
                },
              ]"
              theme="light"
              v-model="activeLocationFilter"
              data-qa="locationsFilter"
              @input="changeLocationsFilter"
            />
          </div>
          <div class="ob-logchain-modal__controls-search">
            <ObAddressInput
              title="Локация"
              :address="this.location"
              placeholder="Найти по названию или адресу"
              :showMap="false"
              :isLocationsOnly="!this.allowAddress"
              :isNoLocations="this.isNoLocations"
              data-qa="addressModal"
              display-exp="russian_address"
              @input="setMapCurrentPoint"
            />
          </div>
          <div class="ob-logchain-modal__controls-buttons">
            <div class="ob-logchain-modal__buttons">
              <ob-button
                label="Сохранить"
                :data-qa="dataQa"
                :disabled="!this.location || this.location === this.value.label"
                @click="save"
              />
              <ob-button
                label="Отмена"
                :type="'flat'"
                :data-qa="dataQa"
                @click="close"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <preloader v-if="isMapLoading" />
  </ObModal>
</template>

<script>
import debounce from "debounce";
import api from "../../../api";
import cloneDeep from "clone-deep";
import ObModal from "common-components/src/obComponents/obModal";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import ObButton from "common-components/src/obComponents/obButton";
import L from "leaflet";
import { latLng, Icon } from "leaflet";
import { LMap, LTileLayer, LMarker, LTooltip, LCircle } from "vue2-leaflet";
import Preloader from "@/services/Preloader/Preloader";
import ControlGroup from "common-components/src/obComponents/obControlGroup";

delete Icon.Default.prototype._getIconUrl;
Icon.Default.mergeOptions({
  iconRetinaUrl: require("leaflet/dist/images/marker-icon-2x.png"),
  iconUrl: require("leaflet/dist/images/marker-icon.png"),
  shadowUrl: require("leaflet/dist/images/marker-shadow.png"),
});

export default {
  components: {
    ObModal,
    ObAddressInput,
    ObButton,
    LMap,
    LTileLayer,
    LMarker,
    LTooltip,
    LCircle,
    Preloader,
    ControlGroup,
  },

  props: {
    mapId: {
      type: String,
      default: "map-id",
    },
    value: {
      type: Object,
      default: () => {},
    },
    locationsTypes: {
      type: Array,
    },
    dataQa: {
      type: String,
    },
    allowAddress: {
      type: Boolean,
      default: true,
    },
    isNoLocations: {
      type: Boolean,
      default: false
    },
    direction: {
      type: String,
    },
    additionalPoint: {
      type: Object,
      default: () => {},
    },
    isRadius: {
      type: Boolean,
      default: true,
    },
    isVisitPoint: {
      type: Boolean,
      default: false,
    },
  },

  locationTypes: {
    "жд станция": "train",
    "аэропорт": "airplane",
    "контейнерный порт": "container",
    "морской порт": "ship",
    "опорная точка": "city",
    "пограничный переход": "police",
    "пункт таможенного оформления/свх": "restrict",
  },

  locationsIconsMap: {
    "bbb964b2-b799-11e9-a2a3-2a2ae2dbcce4": "airport-sm",
    "4adf706e-0be2-4383-b680-a73c959b9e2c": "train-sm",
    "4adf706e-0be2-4383-b680-a73c959b9e4c": "container-sm",
    "5919a99f-d840-4855-b158-5ba957076603": "city-sm",
    "4adf706e-0be2-4383-b680-a73c959b9e3c": "restrict-sm",
    "a2166b4d-27a9-41ce-9fc8-8bfd21baa8d7": "police-sm",
  },

  data() {
    return {
      isAddress: false,
      backup: "",
      addedMarkers: [],
      activeLocationFilter: "5919a99f-d840-4855-b158-5ba957076603",
      location: "",
      selectedLocation: {},
      zoom: 8,
      center: { lat: "", lng: "" },
      url:
        "https://maps.googleapis.com/maps/vt?language=ru-RU&pb=!1m5!1m4!1i{z}!2i{x}!3i{y}!4i256!2m3!1e0!2sm!3i349018013!3m9!2sen-US!3sUS!5e18!12m1!1e47!12m3!1e37!2m1!1ssmartmaps!4e0",
      attribution:
        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      mapOptions: {
        zoomSnap: 0.5,
      },
      showMap: true,
      locations: [],
      circles: [],
      isMapLoading: false,
    };
  },

  methods: {
    isEmptyObj(obj) {
      for (var key in obj) {
        if (obj.hasOwnProperty(key) && !!obj[key]) {
          return false;
        }
      }
      return true;
    },

    async changeLocationsFilter() {
      const bounds = this.$refs.map.mapObject.getBounds();
      const points = [
        {
          lat: bounds._northEast.lat,
          lon: bounds._northEast.lng,
        },
        {
          lat: bounds._southWest.lat,
          lon: bounds._southWest.lng,
        },
      ];

      await this.initLocations(points);
      if (
        this.isRadius &&
        this.activeLocationFilter === "5919a99f-d840-4855-b158-5ba957076603"
      ) {
        await this.initCircles();
      }
    },

    markerZindex(point) {
      if (point.selected === true) {
        return 5000;
      }
      return null;
    },

    async searchAddress(query) {
      if (!query) return;
      let res = await api.geocoder.searchAddressSuggester({
        search_address: query,
      });

      return res.geocodingResult.filter(
        (item) => (item.coordinates.lat !== 0) & (item.coordinates.lon !== 0)
      )[0];
    },

    getLatLng(point) {
      return latLng(point.lat, point.long);
    },

    clickOnMarker($event) {
      if (this.isAddress) {
        return
      }
      this.circles.length = 0;
      let res = this.locations.find(
        (item) =>
          item.lat === $event.latlng.lat && item.long === $event.latlng.lng
      );
      if (!res) {
        res = this.addedMarkers.find(
          (item) =>
            item.lat === $event.latlng.lat && item.long === $event.latlng.lng
        );
      }
      this.location = res.title;
      this.circles.push(res);
      this.selectMarker();
    },

    async setMapCurrentPoint($event) {
      this.isMapLoading = true;
      this.location = $event.label;
      this.selectedLocation = {
        coordinates: {
          lat: $event.coordinates.lat,
          long: $event.coordinates.lon,
        },
        label: $event.title || $event.label,
        icon: $event.icon,
        iconName: $event.iconName || $event.icon,
      };

      if ($event.icon !== "pin") {
        this.isAddress = false;
        const filter = Object.keys(this.$options.locationsIconsMap).find(
          (key) => this.$options.locationsIconsMap[key] === $event.icon
        );
        this.activeLocationFilter = filter;
      } else {
        this.isAddress = true;
      }

      this.center = latLng($event.coordinates.lat, $event.coordinates.lon);

      this.backup = this.location;
    },

    async open() {
      this.$refs.mapPopup.open();
      this.$nextTick(async () => {
        this.isMapLoading = true;

        this.isAddress = this.value.icon === "pin" || this.isVisitPoint;

        this.zoom = this.isAddress ? 16 : 8;

        this.location = this.value.label;

        if (!this.value.label.length) {
          if (!this.isEmptyObj(this.center)) {
            await this.initLocations();
            if (
              this.isRadius &&
              this.activeLocationFilter ===
                "5919a99f-d840-4855-b158-5ba957076603"
            ) {
              this.initCircles();
            }
          }
          this.center = latLng(55.755814, 37.617635);
        } else {
          this.selectedLocation = {
            coordinates: {
              lat: this.value.coordinates.lat,
              long: this.value.coordinates.lon || this.value.coordinates.long,
            },
            label: this.value.title || this.value.label,
            icon: this.value.icon,
            iconName: this.value.iconName || this.value.icon,
          };

          const lat = this.value.coordinates.lat;
          const lon = this.value.coordinates.lon || this.value.coordinates.long;

          if (this.center.lat === lat && this.center.lng === lon) {
            await this.initLocations();
            if (
              this.isRadius &&
              this.activeLocationFilter ===
                "5919a99f-d840-4855-b158-5ba957076603"
            ) {
              this.initCircles();
            }
          }

          const filter =
            Object.keys(this.$options.locationsIconsMap).find(
              (key) => this.$options.locationsIconsMap[key] === this.value.icon
            ) || "5919a99f-d840-4855-b158-5ba957076603";
          this.activeLocationFilter = filter;

          this.center = latLng(lat, lon);
        }
      });
    },

    close() {
      this.backup = this.value.label;
      this.location = "";
      this.addedMarkers = [];
      this.isAddress = false;
      this.locations.length = 0;
      this.circles.length = 0;
      this.selectedLocation = {};
      this.$refs.mapPopup.close();
    },

    async save() {
      this.$emit("input", {
        payload: this.selectedLocation,
        ...(this.direction ? { direction: this.direction } : {}),
        ...(this.additionalPoint
          ? { additionalPoint: this.additionalPoint }
          : {}),
      });

      this.addedMarkers = [];
      this.backup = this.selectedLocation.label;
      this.selectedLocation = {};
      this.isAddress = false;

      this.$refs.mapPopup.close();
    },

    async initLocations(points) {
      let border = points;

      if (!points) {
        const bounds = this.$refs.map.mapObject.getBounds();
        border = [
          {
            lat: bounds._northEast.lat,
            lon: bounds._northEast.lng,
          },
          {
            lat: bounds._southWest.lat,
            lon: bounds._southWest.lng,
          },
        ];
      }

      this.circles.length = 0;

      this.locations.length = 0;

      try {
        if (!this.isAddress) {
          let res = await api.logchain.getLocations({
            points: border,
            locationTypes: [this.activeLocationFilter],
          });

          const temp = res.values.map((item) => {
            return {
              uuid: item.uuid,
              lat: item.coordinates.lat,
              long: item.coordinates.lon,
              title: item.title,
              zeroInterrogationRadius: item.zeroInterrogationRadius,
              iconName: item.typeIcon.toLowerCase() || "pin",
              icon: L.icon({
                iconUrl: require(`./${item.typeIcon.toLowerCase() ||
                  "pin"}.svg`),
                iconSize: [36, 36],
                iconAnchor: [18, 36],
              }),
            };
          });

          this.locations = temp;
          this.zoom = 8;
        } else {
          const address = await this.getAddressByCoordinates(latLng(this.center));
          if (address && address.russian_address) {
            const radius = await api.geocoder.getLocationDescription(
              address.locationUuid
            );
            this.location = address.russian_address;
            this.locations = [
              {
                lat: address.coordinates.lat,
                long: address.coordinates.lon,
                title: address.russian_address,
                locationTitle: address.locationTitle,
                locationUuid: address.locationUuid,
                iconName: "pin",
                locationCoordinates: radius.coordinates,
                zeroInterrogationRadius:
                  radius.location_radius.zero_interrogation_radius,
                icon: L.icon({
                  iconUrl: require(`./pin.svg`),
                  iconSize: [36, 36],
                  iconAnchor: [18, 36],
                }),
                countryShortCode: address.countryShortCode
              },
            ];
            this.zoom = 16;
          } else {
            if (this.selectedLocation.coordinates) {
              this.center = ({lat: this.selectedLocation.coordinates.lat, lng: this.selectedLocation.coordinates.long});
            }
            this.$notification({
              type: "system_notification_error",
              message: "Адрес не найден",
            });
            return;
          }
        }
        if (this.location.length) {
          this.selectMarker();
        }
      } catch (e) {
        console.error(e);
        this.$emit("error");
      } finally {
        this.isMapLoading = false;
      }
    },

    async initCircles() {
      this.circles.length = 0;

      if (!this.location.length) {
        this.circles = cloneDeep(this.locations);
      } else {
        if (this.isAddress && this.locations.length) {
          const { lat, lon: long } = this.locations[0].locationCoordinates;
          this.circles.push(
            {
              lat,
              long,
              zeroInterrogationRadius: this.locations[0].zeroInterrogationRadius
            }
          )
          return
        }

        const { lat, long: lon } = this.selectedLocation.coordinates;

        const baseCircle = await api.geocoder.getBaseByCoordinates(lat, lon);


        if (baseCircle) {
          const circle = this.locations.find(
            (item) => item.uuid === baseCircle.responseBaseLocation[0].uuid
          );

          circle && this.circles.push(circle);
        }
      }

      this.isMapLoading = false;
    },

    selectMarker() {
      const selected = this.locations.find((loc) => loc.selected === true);

      if (selected) {
        const icon = selected.iconName ? selected.iconName : selected.icon;
        selected.icon = L.icon({
          iconUrl: require(`./${icon}.svg`),
          iconSize: [36, 36],
          iconAnchor: [18, 36],
        });

        selected.iconName = icon;

        this.$set(selected, "selected", false);
      }
      const point = this.locations.find((loc) => loc.title === this.location);

      if (point) {
        const icon = point.iconName ? point.iconName : point.icon;

        point.icon = L.icon({
          iconUrl: require(`./${icon}_selected.svg`),
          iconSize: [36, 36],
          iconAnchor: [18, 36],
        });

        point.iconName = icon;

        this.$set(point, "selected", true);

        point.zIndexOffset = 5001;

        this.selectedLocation = {
          coordinates: {
            lat: point.lat,
            long: point.long || point.lon,
          },
          label: point.title,
          icon: point.iconName,
          uuid: point.uuid || point.locationUuid || "",
          locationTitle: point.locationTitle || "",
          countryShortCode: point.countryShortCode
        };
      }
    },

    boundsUpdate: debounce(async function(bounds) {
      const points = [
        {
          lat: bounds._northEast.lat,
          lon: bounds._northEast.lng,
        },
        {
          lat: bounds._southWest.lat,
          lon: bounds._southWest.lng,
        },
      ];
      await this.initLocations(points);
      if (
        this.isRadius &&
        this.activeLocationFilter === "5919a99f-d840-4855-b158-5ba957076603"
      ) {
        this.initCircles();
      }
    }),

    async clickOnMap($event) {
      if (!this.allowAddress) return;

      this.isMapLoading = true;

      this.isAddress = true;

      this.circles.length = 0;

      this.center = latLng($event.latlng);

      this.backup = this.location;
    },

    async getAddressByCoordinates(coordinates) {
      let address = await api.geocoder.getAddressByCoordinates({
        coordinates: coordinates.lat + "," + coordinates.lng,
      });
      return address;
    },
  },
};
</script>

<style lang="scss">
.ob-logchain-modal-wrapper {
  margin: 50px !important;
  padding: 0 !important;

  &.el-dialog.modal-max {
    margin: 40px !important;
    width: calc(100% - 80px) !important;
    height: calc(100% - 80px) !important;
  }

  .ob-logchain-modal {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;

    &__map-container {
      position: absolute;
      left: 0;
      top: 0;
      width: 100%;
      height: 100%;
      div {
        width: auto;
        height: auto;
      }
    }
    &__buttons {
      display: flex;
      justify-content: flex-end;
      align-items: center;
      height: 100%;
    }
    .leaflet-right .leaflet-control {
      margin-right: 0;
    }
    .leaflet-top .leaflet-control {
      margin-top: 0;
    }
    .leaflet-control-attribution.leaflet-control {
      display: none;
    }
    .leaflet-control-zoom.leaflet-bar.leaflet-control {
      position: absolute;
      display: flex;
      flex-direction: column;
      justify-content: center;
      top: 0;
      right: 25px;
      width: 32px;
      box-shadow: none;
      border-radius: 0;
      a {
        position: relative;
        box-shadow: 0px 1px 4px $obAddressModal-obModal_leaflet_a_box_shadow;
        border-radius: 2px;

        &:first-child::after {
          position: absolute;
          z-index: 1;
          background: $background-white;
          bottom: -5px;
          left: 0;
          content: "";
          width: 100%;
          height: 10px;
        }
        &:first-child::before {
          position: absolute;
          z-index: 2;
          background: $obAddressModal-obModal_leaflet_first_child_background_before;
          bottom: -2px;
          left: 5px;
          content: "";
          width: calc(100% - 10px);
          height: 1px;
        }
      }
    }
    &__controls-wrapper {
      position: absolute;
      background: $background-white;
      padding: 20px;
      top: 20px;
      left: 20px;
      width: calc(100% - 40px);
      z-index: 400;
      overflow: hidden;
      opacity: 0.9;
      box-shadow: 0px 4px 4px $obAddressModal-obModal_controls_box_shadow;
      border-radius: 4px;
    }

    &__controls {
      display: flex;
      align-items: center;
    }

    &__controls-locations {
      width: 310px;

      .ob-ctrlgroup__item {
        width: 40px;
        min-width: auto;
        padding: 0;
      }

      .ob-ctrlgroup__item .icon {
        margin-right: 0;
        font-size: 16px;
      }
    }

    &__controls-search {
      flex-grow: 1;
      padding-left: 20px;
      padding-right: 30px;
    }

    &__coords-label {
      display: flex;
      font-size: 14px;
      line-height: 20px;
      align-items: center;
      letter-spacing: 0.2px;
      color: $color-text-base;
    }
  }
}
</style>
